import java.awt.*;

public class BorderLayoutTest {

    public static void main(String[] args) {
	Frame frame = new Frame("Testing border layout");
	
	frame.setLayout(new BorderLayout());
	frame.setBackground(Color.gray);
	frame.add(new Cross(Color.red,    20,  200), BorderLayout.CENTER);
	frame.add(new Cross(Color.pink,   60,  160), BorderLayout.NORTH);
	frame.add(new Cross(Color.orange, 100, 120), BorderLayout.SOUTH);
	frame.add(new Cross(Color.yellow, 140,  80), BorderLayout.EAST);
	frame.add(new Cross(Color.green,  180,  40), BorderLayout.WEST);

	frame.pack();
	frame.setVisible(true);
    }
}



class Cross extends Canvas {

    int w, h;

    public Cross(Color c, int w, int h) {
	setBackground(c);
	this.w = w;
	this.h = h;
    }

    public void paint(Graphics gfx) {
	gfx.setColor(Color.black);
	Dimension dim = getSize();
	gfx.drawRect(0, 0, dim.width-1, dim.height-1);
	gfx.drawLine(0, 0, dim.width-1, dim.height-1);
	gfx.drawLine(dim.width-1, 0, 0, dim.height-1);
    }

    public Dimension getPreferredSize() {
	return new Dimension(w, h);

    }

}
