
#include <X11/Xlib.h>

#include <gcj/cni.h>
#include "no/rwr/x/Display.h"
#include "no/rwr/x/Screen.h"


void no::rwr::x::Screen::initStructure() {
    ::Display* dpy = (::Display*) (display->display);
    ::Screen* screen = ScreenOfDisplay(dpy, screenNumber);
    
    structure = reinterpret_cast<gnu::gcj::RawData*>(screen);
}


jint no::rwr::x::Screen::getRootDepth() {
    ::Screen* screen = (::Screen*) structure;
    return screen->root_depth;
}

jint no::rwr::x::Screen::getRootWindowXID() {
    ::Screen* screen = (::Screen*) structure;
    return RootWindowOfScreen(screen);
}

jint no::rwr::x::Screen::getDefaultColormapXID() {
    ::Screen* screen = (::Screen*) structure;
    return DefaultColormapOfScreen(screen);
}

jint no::rwr::x::Screen::findScreenNumber() {
    ::Screen* screen = (::Screen*) structure;
    return XScreenNumberOfScreen(screen);
}

gnu::gcj::RawData* no::rwr::x::Screen::getRootVisualStructure() {
    ::Screen* screen = (::Screen*) structure;
    ::Visual* visual = DefaultVisualOfScreen(screen);
    return reinterpret_cast<gnu::gcj::RawData*>(visual);
}

